abuild.in 29.3 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
74 75

	
Linux User's avatar
Linux User committed
76 77
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
97
	local i suggestion
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

111 112 113 114 115 116 117 118 119 120
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
121 122 123 124 125 126 127
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

128 129
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
130 131 132 133
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
134
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
135 136 137
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
138 139
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
140

141 142
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
143
			source_has $i || die "$i exists in md5sums but is missing in source"
144 145
		done
	fi
146

147 148 149
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
150 151

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
152 153

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
154 155 156 157
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
158
	local dummy f
159 160 161
	if [ -z "$source" ]; then
		return 0
	fi
162
	if [ -z "$md5sums" ]; then
163
		die "Use 'abuild checksum' to generate/update the checksum(s)"
164
	fi
165 166 167
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
168
	fetch || return 1
169
	msg "Checking md5sums..."
170
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
171 172 173 174
}

uri_fetch() {
	local uri="$1"
175
	local d="${uri##*/}"	# $(basename $uri)
176 177 178 179
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
180 181 182 183 184
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
185
	mkdir -p "$SRCDEST"
186 187 188
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
189
	fi
Linux User's avatar
Linux User committed
190
	msg "Fetching $uri"
191 192
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
193 194
}

195 196
is_remote() {
	case "$1" in
Natanael Copa's avatar
Natanael Copa committed
197
		http://*|ftp://*|https://*)
198 199 200 201 202
			return 0;;
	esac
	return 1
}

203 204 205 206 207
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
208 209 210 211 212
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
213 214 215 216
	fi
	uri_fetch "$uri"
}

217
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
218 219
	local s
	mkdir -p "$srcdir"
220 221
	for s in $source; do
		if is_remote "$s"; then
222
			uri_fetch_mirror "$s" || return 1
223 224 225 226
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
227 228 229
	done
}

230 231 232 233
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
234
# unpack the sources
235
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
236
	local u
237
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
238 239 240 241
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
242
			*.tar.gz|*.tgz)
243
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
244 245
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
246
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
247
				tar -C "$srcdir" -jxf "$s" || return 1;;
248 249 250 251
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
252 253 254
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
255 256 257
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
258 259 260 261
		esac
	done
}

262 263 264 265
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
266 267
# cleanup source and package dir
clean() {
268
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
269
	rm -rf "$srcdir"
270
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
271 272 273 274 275 276
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
277 278 279 280
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
281 282 283 284 285
	done
}

cleanpkg() {
	local i
286
	getpkgver || return 1
287
	msg "Cleaning built packages..."
288
	for i in $pkgname $subpackages; do
289 290
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
291
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
292
	done
293
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
294 295
}

296 297 298
# clean all packages except current
cleanoldpkg() {
	local i j
299
	getpkgver || return 1
300 301 302 303 304 305 306 307 308
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
327 328
runpart() {
	local part=$1
329
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
330 331 332 333
	$part || die "$part failed"
}

# override those in your build script
334 335 336 337 338 339 340 341
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
342 343 344 345
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
346
build() {
347
	:
Natanael Copa's avatar
Natanael Copa committed
348 349
}

350 351 352 353 354 355
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
356 357 358 359 360 361 362 363 364
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

365
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
366
	if [ -z "$subpackages" ]; then
367 368
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
369 370
	local i
	cd "$startdir"
371
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
372 373
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
374
		msg "Running split function $func..."
375
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
376
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
377 378 379
	done
}

380
prepare_metafiles() {
381
	getpkgver || return 1
382 383
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
384
	local dir=${subpkgdir:-$pkgdir}
385
	local pkg="$name-$pkgver-r$pkgrel.apk"
386
	local pkginfo="$controldir"/.PKGINFO
387
	local sub
Natanael Copa's avatar
Natanael Copa committed
388 389 390
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
391
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
392 393
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
394 395 396 397
	local parch="$CARCH"
	if [ "$arch" = "noarch" ]; then
		parch="noarch"
	fi
Natanael Copa's avatar
Natanael Copa committed
398

399
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
400
	if [ -n "$FAKEROOTKEY" ]; then
401
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
402
	fi
403 404
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
405
pkgname = $name
406
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
407 408 409 410 411
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
412
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
413
EOF
414 415
	local i deps
	deps="$depends"
416
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
417 418
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
419 420 421 422 423
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
424 425
	fi
	
Natanael Copa's avatar
Natanael Copa committed
426
	for i in $license; do
427
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
428 429
	done
	for i in $replaces; do
430
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
431
	done
432
	for i in $deps; do
433
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
434 435
	done
	for i in $conflicts; do
436
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
437 438
	done
	for i in $provides; do
439
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
440 441
	done
	for i in $backup; do
442
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
443
	done
Natanael Copa's avatar
Natanael Copa committed
444 445 446
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
447 448

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
449
	for i in $install ${triggers%%:*}; do
450 451
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
452
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
453 454
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
455
			*) 	error "$script: Invalid install/trigger script"
456 457 458
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
459
		cp "$startdir/$i" "$controldir/$script" || return 1
460
		chmod +x "$controldir/$script"
461 462
		metafiles="$metafiles $script"
	done
463
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
464
}
465

466 467 468
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
469
	# lets tell all the .so files this package provides in .provides-so
470 471
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
472 473 474 475 476
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
477
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
478 479 480
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
481 482
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
483
	done
Natanael Copa's avatar
Natanael Copa committed
484 485
}

486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
	else
		[ "$arch" = "noarch" ] && return 0
		error "No arch specific binaries found so arch should be set to \"noarch\""
		return 1
	fi
	return 0
}

513
prepare_package() {
514
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
515
	stripbin
516 517
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
518 519 520 521 522 523 524 525
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

549 550 551
trace_apk_deps() {
	local name="$1"
	local dir="$2"
552
	local i= j= found= autodeps= deppkgs= missing= so_paths=
553
	msg "Tracing dependencies for $name..."
554 555 556
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
557
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
558 559 560 561 562 563 564
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
	if grep -q -w '^libpthread.so.*' "$dir"/.needs-so 2>/dev/null \
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
565
		msg "  added libgcc (due to libpthread)"
566
	fi
567
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
568
		found=
569
		# first check if its provide by same apkbuild
570
		for j in "$dir"/../.control.*/.provides-so; do
571
			grep -w "$i" "$j" >/dev/null || continue
572
			found=${j%/.provides-so}
573
			found=${found##*/.control.}
574
			break
575
		done
576 577 578 579 580 581
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
582
		fi
583 584 585 586 587 588 589
	done

	# find all packages that holds the so files
	so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
	deppkgs=$($APK info -q -W $so_files) || return 1
	
	for found in $self_provided $deppkgs; do
590
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
591 592 593
			warning "You can remove '$found' from depends"
			continue
		fi
594 595
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
596
			msg "  added $found"
597
		fi
598
	done
599

600 601 602 603 604 605 606
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

607 608
create_apks() {
	local file
609
	getpkgver || return 1
610
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
611 612 613
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
614
		local apk=$name-$ver.apk
615
		local datadir="$pkgbasedir"/$name
616 617

		trace_apk_deps "$name" "$dir" || return 1
618
		msg "Creating $apk..."
619
		(
620 621
		cd "$datadir"
		# data.tar.gz
622 623 624 625 626 627
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
628 629 630 631 632 633

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
634
		cd "$dir"
635 636
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
637
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
638

639 640 641
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
642 643 644
	done
}

645
update_abuildrepo() {
646
	if ! apk_up2date || [ -n "$force" ]; then
647
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
648
			&& prepare && mkusers && rootpkg || return 1
649
	fi
650

651
	local apk
652 653
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
654 655 656 657 658 659 660 661 662

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
663
	for apk in $(listpkg); do
664
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
665 666
	done

667
	msg "Updating the cached abuild repository index..."
668 669 670 671 672
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
673
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
674 675
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
676 677 678
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
679
	chmod 644 APKINDEX.tar.gz
680 681
}

682
# predefined splitfunc doc
683
default_doc() {
684
	depends="$depends_doc"
685
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
686
	triggers="$triggers_doc"
687
	arch=${arch_doc:-"noarch"}
Natanael Copa's avatar
Natanael Copa committed
688
	local i
689
	for i in doc man info html sgml licenses gtk-doc; do
690 691 692
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
693 694
		fi
	done
695 696 697
	
	rm -f "$subpkgdir/usr/share/info/dir"

698 699 700
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
701 702 703 704

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
705
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
706 707 708
	return 0
}

709 710 711 712
doc() {
	default_doc
}

713
# predefined splitfunc mod
714
default_mod() {
715
	depends="$kernel $depends_mod"
716
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
717
	for i in firmware modules; do
718 719 720
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
721
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
722 723 724 725
		fi
	done
}

726 727 728 729
mod() {
	default_mod
}

730
# predefined splitfunc dev
731
default_dev() {
732
	local i= j=
733
	depends="$pkgname $depends_dev"
734
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
735
	triggers="$triggers_dev"
736 737 738 739
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
740
	cd "$pkgdir" || return 0
741 742
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
743
			usr/share/vala/vapi usr/share/gir-[0-9]*\
744 745 746
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
747 748
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
749
			mkdir -p "$d"
750
			mv "$pkgdir/$i" "$d"
751
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
752 753
		fi
	done
754 755 756 757 758 759 760
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
761
	return 0
Natanael Copa's avatar
Natanael Copa committed
762 763
}

764 765 766 767
dev() {
	default_dev
}

768 769 770 771
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
772 773
# build and package in fakeroot
rootpkg() {
774 775 776 777
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
778
		do_build=package
779
	fi
Natanael Copa's avatar
Natanael Copa committed
780
	cd "$startdir"
781
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
782
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
783 784
		prepare_subpackages \
		prepare_package \
785
		create_apks
Natanael Copa's avatar
Natanael Copa committed
786 787 788
}

srcpkg() {
789
	getpkgver || return 1
790
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
791
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
792 793 794 795 796
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
797
	msg "Creating source package $p.src.tar.gz..."
798
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
799 800
}

Natanael Copa's avatar
Natanael Copa committed
801 802
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
803
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
804 805
}

806
# check if package is up to date
807
apk_up2date() {
808
	getpkgver || return 1
809
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
810
	local i s
Natanael Copa's avatar
Natanael Copa committed
811
	cd "$startdir"
812 813 814 815 816
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

817
	for i in $source APKBUILD; do
818 819 820 821 822 823
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
824 825 826 827 828 829 830
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

831
abuildindex_up2date() {
832
	local i apk
833
	getpkgver || return 1
834 835
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
836
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
837 838 839 840 841
	done
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
842
	check_arch || return 0
843 844 845 846 847 848 849
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
850 851
}

852 853 854 855 856 857 858
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
859 860
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
861 862 863 864
		pkgname=
		subpackages=
		depends=
		makedepends=
865
		. $i
866
		dir=${i%/APKBUILD}
867
		deps=
868
		# filter out conflicts from deps and version info
869 870 871 872
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
873
			deps="$deps ${j%%[<>=]*}"
874
		done
875
		for j in $pkgname $subpackages; do
876
			echo "o ${j%%:*} $dir"
877
			set -- $deps
878 879 880 881 882 883 884
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
885 886
		done
	done
887
	)
888 889
}

890
deptrace() {
891 892 893
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
894
		deps="$deps ${i%%[<>=]*}"
895
	done
896
	[ -z "$deps" ] && return 0
897 898 899
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
900
			$APK info -q | sort |  sed 's/^/i /'
901
		fi
902
	) | awk -v pkgs="$deps" '
903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
928
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
929
	local filtered_deps= conflicts=
930
	[ -n "$nodeps" ] && return 0
931
	msg "Analyzing dependencies..."
932

933 934 935
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
936
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
937 938
	done

939
	installed_deps=$($APK info -e $deps)
940
	# find which deps are missing
941
	for i in $deps; do
942
		if [ "${i#\!}" != "$i" ]; then
943
			$APK info -q -e "${i#\!}" \
944
				&& conflicts="$conflicts ${i#\!}"
945
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
946 947 948
			missing="$missing $i"
		fi
	done
949
	
950
	if [ -n "$conflicts" ]; then
951 952
		error "Conflicting package(s) installed:$conflicts"
		return 1
953 954 955 956 957 958 959 960
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
961

962
	uninstall_after=".makedepends-$pkgname $uninstall_after"
963
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
964 965
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
966
		$SUDO $APK add --repository "$abuildrepo" \
967 968
			--wait 30 \
			--simulate --quiet $deps || return 1
969
		$SUDO $APK add --repository "$abuildrepo" \
970
			--wait 30 \
971 972
			--virtual .makedepends-$pkgname $deps \
			&& return 0
973
	fi
974 975
	
	[ -z "$recursive" ] && return 1
976 977 978

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
979
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
980
		if [ -z "$m" ]; then
981 982 983
			missing="$missing $i"
		fi
	done
984 985
	
	for i in $(deptrace $missing); do
986 987 988
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
989 990 991 992 993 994 995 996 997 998

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
999
			$recursive $upgrade $color_opt abuildindex || return 1
1000
	done
1001
	$SUDO $APK add -u --repository "$abuildrepo" \
1002
		--wait 30 \
1003
		--virtual .makedepends-$pkgname $deps
1004 1005
}

1006
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
1007 1008
checksum() {
	local s files
1009
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
1010
	fetch
1011
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
1012 1013 1014 1015
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
1016 1017
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
1018 1019
}

1020
stripbin() {
1021
	local bin
1022 1023 1024
	if options_has "!strip" || [ "$arch" = "noarch" ]; then
		return 0
	fi
1025 1026
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
1027 1028 1029
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
1030 1031
}

1032 1033 1034
# simply list target apks
listpkg() {
	local i 
1035
	getpkgver || return 1
1036 1037 1038 1039 1040
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
1041 1042 1043 1044 1045 1046 1047 1048
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
1049 1050 1051 1052 1053 1054 1055 1056
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

1057 1058 1059 1060 1061 1062 1063 1064 1065 1066 1067
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

1068 1069 1070 1071 1072 1073
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
1074
		i=${i%%[<>=]*}
1075 1076 1077 1078 1079 1080
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

1081 1082 1083 1084
options_has() {
	list_has "$1" $options
}

1085
depends_has() {
1086
	deplist_has "$1" $depends
1087 1088
}

Natanael Copa's avatar
Natanael Copa committed
1089
makedepends_has() {
1090
	deplist_has "$1" $makedepends
Natanael Copa's avatar
Natanael Copa committed
1091 1092
}

Natanael Copa's avatar
Natanael Copa committed
1093 1094 1095 1096
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
1097 1098 1099 1100
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
1101 1102
# install package after build
post_add() {
1103
	getpkgver || return 1
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1104 1105 1106 1107 1108 1109
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
1110
	deps=$($APK index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1111 1112 1113 1114 1115
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
1116
	$SUDO $APK add --wait 30 -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1117 1118
}

1119
installdeps() {
1120
	local deps i